<?php
error_reporting(0);

$pz_photofolder = "images/";
$pz_thumbs_med_maxwidth = 450;
$pz_thumbs_med_maxheight = 600;

require_once( dirname(dirname(dirname(dirname( __FILE__ )))) . "/wp-config.php");
require_once( dirname(dirname(dirname(dirname( __FILE__ )))) . "/wp-admin/phpWatermark.inc.php");


function unzip($file, $path) {
	$zip = zip_open($file);
  if ($zip) {
   while ($zip_entry = zip_read($zip)) {
     if (zip_entry_filesize($zip_entry) > 0) {	
       if(!file_exists($path)) {
         $tmp = $path;
         if(!file_exists($tmp)) {mkdir($tmp, 0777);
           }
         }
       if (zip_entry_open($zip, $zip_entry, "r")) {
         $fd = fopen($path . '/' . zip_entry_name($zip_entry), 'w');
         fwrite($fd, zip_entry_read($zip_entry, zip_entry_filesize($zip_entry)));
         fclose($fd);
         zip_entry_close($zip_entry);
       }
     }
   }
   zip_close($zip);
  }
}

get_currentuserinfo();
if ($user_level == 0) //Checks to see if user has logged in
        die (__("Try logging in"));

$pz_home_path = get_settings('home');
if ( $pz_home_path != '' && $pz_home_path != get_settings('siteurl') ) {
	$pz_blogurl = get_settings('home');
	$pz_siteurl = get_settings('siteurl');
        $home_path = parse_url($pz_home_path);
	$home_path = $home_path['path'];
	$root = str_replace($_SERVER["PHP_SELF"], '', $_SERVER["SCRIPT_FILENAME"]);
	$home_path = trailingslashit($root . $home_path);
} else {
	$pz_siteurl = get_settings('siteurl');
	$pz_blogurl = get_settings('siteurl');
	$home_path = ABSPATH;
	$home_path = trailingslashit($root . $home_path);
}
$pz_photosaddress = $pz_blogurl . $pz_photofolder;
$pz_photospath = $home_path . $pz_photofolder;


// for future puporses
$pz_moveto_path = $pz_photospath;
$pz_viewsaddress = $pz_photosaddress;

if ($_POST['submit']) {
        pz_uploading();
} else if($_GET['pz_dir']){
	if ($_GET['pz_del']){
		pz_recurse_del($pz_photospath.$_GET['pz_dir']);
		pz_upload_form();
	} elseif ($_GET['pz_thumbs']){
		pz_create_thumbs($pz_moveto_path.$_GET['pz_dir']."",$_GET['pz_dir']);
	}
	else 	{
		pz_photoslinks($_GET['pz_dir']);
	} 
} else {
        pz_upload_form();
}

?>




<?php

function pz_recurse_del($dirname)
{ // recursive function to delete
  // all subdirectories and contents:
  if(is_dir($dirname))$dir_handle=opendir($dirname);
  while($file=readdir($dir_handle))
  {
    if($file!="." && $file!="..")
    {
      if(!is_dir($dirname."/".$file))unlink ($dirname."/".$file);
      else pz_recurse_del($dirname."/".$file);
    }
  }
  closedir($dir_handle);
  rmdir($dirname);
  return true;
}

function pz_flatten_dir($dirname,$folder)
{ // recursive function to delete
  // all subdirectories and contents:
  if(is_dir($dirname))$dir_handle=opendir($dirname);
  while($file=readdir($dir_handle))
  {
    if($file!="." && $file!=".." ) //&& (!preg_match('/^\.\.?$/',$file))
    {
      if(!is_dir($dirname."/".$file)) rename($dirname."/".$file,$folder.$file );
      else {
	      pz_flatten_dir($dirname."/".$file,$folder);
	      rmdir($dirname."/".$file);
      }
    }
  }
  closedir($dir_handle);
  return true;
}


function pz_resize_small($fn, $target){
	if (!function_exists("exif_thumbnail")) return false;
	$image = exif_thumbnail($fn); //, $width, $height, $type

	   if ($image!==false) {
		   //if there is a good enough thumbnail to use, we have it here.
		   //extract it and put it in the file, call it [original image name].thumb.jpg
		 $handle = fopen ($target, 'a');
		 //write the thumbnail image
		 fwrite($handle, $image);
		 return true;
	   } else {
		 // no thumbnail available, handle the error here
		 //echo "No thumbnail available for file ".$fn."<br>";
		 return false;
	   }
}

function addMark ($img) {
	global $addWaterMarkPath, $addWaterMarkPos, $addWaterMarkType, $addWaterMarkColor;
		$wm = new watermark($img);
        $wm->setPosition($addWaterMarkPos);
        if ($addWaterMarkType == "TEXT") $wm->setFixedColor($addWaterMarkColor);

        $wm->addWatermark($addWaterMarkPath, $addWaterMarkType);
        $img = $wm->getMarkedImage();
return $img;	

}



function pz_resize($image_path, $target_path, $max_width, $max_height){
	//echo "<br/>Processing $image_path --> $target_path<br/>";
	# Load image

	$img = null;
	$ext = strtolower(end(explode('.', $image_path)));
	if ($ext == 'jpg' || $ext == 'jpeg') {
		$img = @imagecreatefromjpeg($image_path);
		if ($_POST['copyr'] == 'on') imagejpeg(addMark ($img),$image_path);
	} else if ($ext == 'png') {
		$img = @imagecreatefrompng($image_path);
		if ($_POST['copyr'] == 'on') imagepng(addMark ($img),$image_path);
	# Only if your version of GD includes GIF support
	} else if ($ext == 'gif') {
		$img = @imagecreatefrompng($image_path);
		if ($_POST['copyr'] == 'on') imagegif(addMark ($img),$image_path);
	}
	
	# If an image was successfully loaded, test the image for size
	if ($img) {
	
		# Get image size and scale ratio
		$width = imagesx($img);
		$height = imagesy($img);
		$scale = min($max_width/$width, $max_height/$height);
	
		# If the image is larger than the max shrink it
		if ($scale < 1) {
			$new_width = floor($scale*$width);
			$new_height = floor($scale*$height);
	
			# Create a new temporary image
			$tmp_img = imagecreatetruecolor($new_width, $new_height);
	
			# Copy and resize old image into new image
			//imagecopyresized  imagecopyresampled
			imagecopyresampled($tmp_img, $img, 0, 0, 0, 0,
							 $new_width, $new_height, $width, $height);
			imagedestroy($img);
			$img = $tmp_img;
		}
	}
	
	# Create error image if necessary
	if (!$img) {
		$img = imagecreate($max_width, $max_height);
		imagecolorallocate($img,0,0,0);
		$c = imagecolorallocate($img,70,70,70);
		imageline($img,0,0,$max_width,$max_height,$c2);
		imageline($img,$max_width,0,0,$max_height,$c2);
	}
	
	# Save the image
	imagejpeg($img, $target_path);
}

function pz_get_images($mydir){
	$images =  array();
	$opendir = opendir($mydir);
	while(false !==($fn = readdir($opendir))) //scan through the whole directory 
	{//open while
		$ext = strtolower(end(explode('.', $fn)));
		$allowed_types = explode(",","png,jpg,jpeg,gif");
		if(preg_match('/^\.\.?$/',$fn)){
			//hidden files
		}
		elseif(is_dir($mydir.$fn)) { //"{realpath($maindir)}/".
			//dir //echo $fn;
		}else if (in_array($ext, $allowed_types)  ){
			array_push($images,$fn);
		}
	}
	closedir($opendir);
	return $images;
}

function pz_get_dirs($mydir){
	$dirs =  array();
	$opendir = opendir($mydir);
	while(false !==($fn = readdir($opendir))) //scan through the whole directory 
	{//open while
		if(preg_match('/^\.\.?$/',$fn)){
			//hidden files
		}
		elseif(is_dir($mydir.$fn)) {
			array_push($dirs,$fn);
		}
	}
	closedir($opendir);
	return $dirs;
}

function pz_create_thumbs($mydir, $pz_dir){
	global $pz_thumbs_med_maxwidth, $pz_thumbs_med_maxheight;
	if (!file_exists("$mydir/thumbs1/")) mkdir ("$mydir/thumbs1/");
	if (!file_exists("$mydir/thumbs2/")) mkdir ("$mydir/thumbs2/");
	$images = pz_get_images($mydir);
	pz_html_head();
	echo "Please be patient while the server processes ".count($images)." photos.<br/>";
	for ($i=0;$i<count($images);$i++){
		$fn = $images[$i];
		echo "Working on photo #".($i+1).": $fn ...";
		flush(); //needed to display each image progress
		
		$resized = pz_resize_small("$mydir/$fn", "$mydir/thumbs1/".$fn."")
		  or pz_resize("$mydir/$fn","$mydir/thumbs1/".$fn, 150, 150);
		
		echo " done.<br/>";
		flush();
		
		$image = pz_resize("$mydir/$fn","$mydir/thumbs2/".$fn, $pz_thumbs_med_maxwidth, $pz_thumbs_med_maxheight);
	}
	?>
	<SCRIPT LANGUAGE="JavaScript">
		window.location="<?php echo $_SERVER['SCRIPT_NAME']; ?>?pz_dir=<?=$pz_dir?>";
	</script>';
	<meta http-equiv="Refresh" content="0; url=<?php echo $_SERVER['SCRIPT_NAME']; ?>?pz_dir=<?=$pz_dir?>">
	Click here to continue<a href="<?php echo $_SERVER['SCRIPT_NAME']; ?>?pz_dir=<?=$pz_dir?>"></a>
	<?php
	pz_html_foot();
	
} //end pz_create_thumbs

function pz_uploading() {
	// this methods gets the upload file and unzips it.
	global $pz_moveto_path;
 
	$old = umask(0); // umask so permissions will be set right
	
	is_dir($pz_moveto_path) or mkdir($pz_moveto_path,0777) or die("No photo directory. Make sure your script have permissions.");
	$pz_zip_file = $_FILES['zipname']['tmp_name'];
	$pz_zip_name = $_FILES['zipname']['name']; 
	
	$pz_folder = $_POST['foldername'];
	if (empty($pz_folder)) $pz_folder = substr($pz_zip_name,0,strlen($pz_zip_name)-4);

//	shell_exec ("unzip $pz_zip_file -d $pz_moveto_path$pz_folder") or die("Unable to run unzip");
	unzip ($pz_zip_file,$pz_moveto_path . $pz_folder);
	unlink($pz_zip_file);
	pz_flatten_dir($pz_moveto_path.$pz_folder."/",$pz_moveto_path.$pz_folder."/");
	
	pz_create_thumbs($pz_moveto_path.$pz_folder."",$pz_folder);//pz_thumbnailing($pz_folder);
	
	umask($old);
	
}


function pz_photoslinks($pz_folder){
	global $pz_moveto_path,$pz_viewsaddress;
	$images = pz_get_images($pz_moveto_path.$pz_folder);
	$pz_viewsaddress.=$pz_folder;
	pz_html_head();
?>


<input type="button" onClick="targetopener(false);" value="<?php _e('Insert all') ?>" />
<input type="button" onClick="targetopener(true);" value="<?php _e('Insert and Close') ?>" />
<input type="button" onClick="window.close();" value="<?php _e('Close window') ?>" />

<p>
For now, clicking <strong>insert</strong> places all the <em>medium sized</em> <strong>thumbnails </strong>with <strong>links</strong> to the <em>full sized</em> photo which open in default window target.
<br/>
<input type="button" onClick="window.location='<?php echo $_SERVER['SCRIPT_NAME']; ?>';" value="<?php _e('Upload again') ?>" />
<input type="button" onClick="return pz_del('<?=$pz_folder?>');" value="<?php _e('Delete pics') ?>" />
</p>


<div id="pz_preview"></div>
<br/>You can copy and paste the html found here too.
<textarea id="pz_code" width="350"></textarea>
<script type="text/javascript">
var pz_blah = '<?=implode(",",$images)?>'; 
var pz_base = '<?=$pz_viewsaddress?>/';
var pz_preview = document.getElementById("pz_preview");
var pz_code = document.getElementById("pz_code");
var pz_images = pz_blah.split(",");

var mid_thumbs_html = "";
for (var i=0; i < pz_images.length ; i++ ) {
  pz_preview.innerHTML += '<a href="'+pz_base+pz_images[i]+'"><img src="'+pz_base+'thumbs1/'+pz_images[i]+'"/></a>&nbsp;';
  mid_thumbs_html += '<a href="'+pz_base+pz_images[i]+'" target="_blank"><img src="'+pz_base+'thumbs2/'+pz_images[i]+'"/></a>\n\n';
}
pz_blah = mid_thumbs_html;
pz_code.value = mid_thumbs_html;
	
function targetopener(closeme) {
        if (! (window.focus && window.opener))return true;
        window.opener.focus();
        window.opener.document.post.content.value += pz_blah;
        if (closeme)window.close();
        return false;
}
//-->
</script>
<?php
pz_html_foot();
} //end uploading ?>




<?php 
function pz_upload_form() {
	global $pz_moveto_path,$pz_viewsaddress, $addWaterMark; 
;
	pz_html_head(); ?>

<h3>Upload a Zip file of photos!</h3>
<p><?php printf(__('Yuch Yuck.. Need some styling on the appearance here.')) ?></p>
    <form action="<?php echo $_SERVER['SCRIPT_NAME']; ?>" method="post" enctype="multipart/form-data">
    <p>
	Add WaterMark:&nbsp;<input type="checkbox" name="copyr" id="copyr" <?=$addWaterMark; ?><br />
      <label for="zipname"><?php _e('File:') ?></label>
      <br />
	<input type="hidden" name="MAX_FILE_SIZE" value="<?php echo 9999999* 1024 ?>" />
    <input type="file" name="zipname" id="zipname" size="35" class="uploadform" /></p>
    <p>
    <label for="foldername"><?php _e('Folder Name: (If blank, photos will be upload into folder based on zip filename.)') ?></label><br />
    <input type="text" name="foldername" id="foldername" size="30" class="uploadform" />
    </p>
	
	<p><input type="submit" name="submit" value="<?php _e('Upload File') ?>" /></p>
    </form>

	<p><a href="#" onClick="window.close()"><?php _e('Close window') ?></a></p>
	
<h4>Photo Folders Management</h4>
<?php
$dirs = pz_get_dirs($pz_moveto_path);
for ($i=0;$i<count($dirs);$i++){
	$a = $dirs[$i];
	?>
	<br/><a href="javascript:pz_folder('<?=$a?>');"><?=$a?></a> <small><a href="javascript:pz_thumbs('<?=$a?>');">create thumbs</a>, <a href="javascript:pz_del('<?=$a?>');">delete</a></small>
	<?php
}

pz_html_foot(); 
} //end upload_form 
?>

<?php
function pz_html_head(){
	?>
<html>
<head>
<style>
//stolen from http://labs.silverorange.com/images/tabsupdate/basic.css
body, div, td, th, h2, h3, h4, p { /* redundant rules for bad browsers  */  
    font-family: verdana,sans-serif;
	font-size:    x-small;
	voice-family: "\"}\"";
	voice-family: inherit;
	font-size: small;
	color: #333;
} 
body {
	background: #EDEBE3;
	color: #333;
	padding: 1em 20px 3em 20px;
	margin: 0;
}
div#pz_preview { overflow: auto;
height :180px; width:400px;}
</style>
<script type="text/javascript">
function pz_del(dir){
	if(!confirm("Are you sure you want to delete these photos?")) return false;
	window.location='<?php echo $_SERVER['SCRIPT_NAME']; ?>?pz_dir='+dir+'&pz_del=1'
}
function pz_folder(dir){
	window.location='<?php echo $_SERVER['SCRIPT_NAME']; ?>?pz_dir='+dir+''
}
function pz_thumbs(dir){
	window.location='<?php echo $_SERVER['SCRIPT_NAME']; ?>?pz_dir='+dir+'&pz_thumbs=1'
}
</script>
</head>
<body>
	<?php
}

function pz_html_foot(){
	?>
</body>
</html>
	<?php
}


?>